LeetCode Blog

Solutions for LeetCode problems - Written by ansidev

2400. Number of Ways to Reach a Position After Exactly k Steps

Author's avatar
ansidev Posted on October 24, 2022

Problem

You are given two positive integers startPos and endPos. Initially, you are standing at position startPos on an infinite number line. With one step, you can move either one position to the left, or one position to the right.

Given a positive integer k, return the number of different ways to reach the position endPos starting from startPos, such that you perform exactly k steps. Since the answer may be very large, return it modulo 109 + 7.

Two ways are considered different if the order of the steps made is not exactly the same.

Note that the number line includes negative integers.

Example 1:

Input: startPos = 1, endPos = 2, k = 3
Output: 3
Explanation: We can reach position 2 from 1 in exactly 3 steps in three ways:
- 1 -> 2 -> 3 -> 2.
- 1 -> 2 -> 1 -> 2.
- 1 -> 0 -> 1 -> 2.
It can be proven that no other way is possible, so we return 3.

Example 2:

Input: startPos = 2, endPos = 5, k = 10
Output: 0
Explanation: It is impossible to reach position 5 from position 2 in exactly 10 steps.

Constraints:

Analysis

Assuming d is the distance between startPos and endPos => d = abs(startPos - endPos).

=> -999 <= startPos - endPos <= 999

=> 0 <= d = abs(startPos - endPos) <= 999

For k is the numbers of steps and d is the distance between startPos and endPos, the number of ways is:

For k steps, the maximum distance is k.

Example values:

Approaches

Approach 1

Approach

Solutions

func numberOfWays(startPos int, endPos int, k int) int {
	const mod = 1e9 + 7
	dp := [1001][1001]int{}
	for i := 1; i <= 1000; i++ {
		dp[i][i] = 1
		for j := 0; j < i; j++ {
			dp[i][j] = (dp[i-1][abs(j-1)] + dp[i-1][j+1]) % mod
		}
	}

	return dp[k][abs(startPos-endPos)]
}

func abs(x int) int {
	if x >= 0 {
		return x
	}

	return -x
}

References